<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: zone-include.php 1534 2005-02-10 16:48:13Z scott $
*/



    // Include required files
    include_once 'config.php';
    include_once '../libraries/common.php';
    include_once '../libraries/dba.php';
    include_once '../libraries/html.php';
    include_once 'lib-zones.inc.php';
    
    // Security check
    phpAds_checkAccess(phpAds_Admin + phpAds_Agency + phpAds_Affiliate);

    // Get input parameters
    $publisherId    = MAX_getValue('affiliateid');
    $zoneId         = MAX_getValue('zoneid');
    $advertiserId   = MAX_getValue('clientid');
    $placementId    = MAX_getValue('campaignid');
    $adId           = MAX_getValue('bannerid');
    $action         = MAX_getValue('action');
    $aCurrent       = MAX_getValue('includebanner');
    $hideInactive   = MAX_getStoredValue('hideinactive', ($phpAds_config['gui_hide_inactive'] == 't'));
    $listorder      = MAX_getStoredValue('listorder', 'name');
    $orderdirection = MAX_getStoredValue('orderdirection', 'up');
    $selection      = MAX_getValue('selection');
    $showMatchingAds = MAX_getStoredValue('showbanners', ($phpAds_config['gui_show_matching'] == 't'));
    $showParentPlacements = MAX_getStoredValue('showcampaigns', ($phpAds_config['gui_show_parents'] == 't'));
    $submit         = MAX_getValue('submit');
    $view           = MAX_getStoredValue('view', 'ad');
    
    // Initialise some parameters
    $pageName = basename($_SERVER['PHP_SELF']);
    $tabIndex = 1;
    $agencyId = phpAds_getAgencyID();
    $aEntities = array('affiliateid' => $publisherId, 'zoneid' => $zoneId);
    
    // Parameter check
    if (!MAX_checkZone($publisherId, $zoneId)) {
        // TODO:  Change the code below to be standard...
        phpAds_PageHeader('2');
        phpAds_Die ($strAccessDenied, $strNotAdmin);
    }

    if (isset($action)) {
        if ($action == 'set' && $view == 'placement' && !empty($placementId)) {
            $aLinkedPlacements = MAX_getEntities('placement_zone_assoc', array('zone_id' => $zoneId), false, 'placement_id');
            if (!isset($aLinkedPlacements[$placementId])) {
                MAX_addEntity('placement_zone_assoc', array('zone_id' => $zoneId, 'placement_id' => $placementId));
            }
            
            MAX_addLinkedAdsToZone($zoneId, $placementId);
            
        } elseif ($action == 'set' && $view == 'ad' && !empty($adId)) {
            $aLinkedAds = MAX_getEntities('ad_zone_assoc', array('zone_id' => $zoneId), false, 'ad_id');
            if (!isset($aLinkedAds[$adId])) {
                MAX_addEntity('ad_zone_assoc', array('zone_id' => $zoneId, 'ad_id' => $adId));
            }
        } elseif ($action == 'remove' && $view == 'placement' && !empty($placementId)) {
            MAX_removeEntities('placement_zone_assoc', array('zone_id' => $zoneId, 'placement_id' => $placementId));
        } elseif ($action == 'remove' && $view == 'ad' && !empty($adId)) {
            MAX_removeEntities('ad_zone_assoc', array('zone_id' => $zoneId, 'ad_id' => $adId));
        }
        Header("Location: zone-include.php?affiliateid=$publisherId&zoneid=$zoneId");
        exit;
    }
    
    if (isset($submit)) {
        switch ($view) {
            case 'placement' :
                $aPrevious = MAX_getEntities('placement_zone_assoc', array('zone_id' => $zoneId));
                $key = 'placement_id';
                break;
            case 'ad' :
                $aPrevious = MAX_getEntities('ad_zone_assoc', array('zone_id' => $zoneId));
                $key = 'ad_id';
                break;
        }
        
        // First, remove any placements/adverts that should be deleted.
        if (!empty($aPrevious)) {
            foreach ($aPrevious as $aZoneAssoc) {
                $id = $aZoneAssoc[$key];
                if (empty($aCurrent[$id])) {
                    // The user has removed this zone link
                    $aParameters = array('zone_id' => $zoneId, $key => $id);
                    if ($view == 'placement') {
                        MAX_removeEntities('placement_zone_assoc', $aParameters);
                    } else {
                        MAX_removeEntities('ad_zone_assoc', $aParameters);
                    }
                } else {
                    // Remove this key, because it is already there and does not need to be added again.
                    unset($aCurrent[$id]);
                }
            }
        }
        
        if (!empty($aCurrent)) {
            foreach ($aCurrent as $id => $value) {
                $aVariables = array('zone_id' => $zoneId, $key => $id);
                if ($view == 'placement') {
                    MAX_addEntity('placement_zone_assoc', $aVariables);
                } else {
                    MAX_addEntity('ad_zone_assoc', $aVariables);
                }
            }
        }
                
        // Move on to the next page
        Header("Location: zone-probability.php?affiliateid=$publisherId&zoneid=$zoneId");
        exit;
    }
    // Display initial parameters...
    $tabIndex = 1;

    $aOtherPublishers = MAX_getEntities('publisher', array('agency_id' => $agencyId));
    $aOtherZones = MAX_getEntities('zone', array('publisher_id' => $publisherId));
    MAX_displayNavigationZone($pageName, $aOtherPublishers, $aOtherZones, $aEntities);
    
    MAX_displayPlacementAdSelectionViewForm($publisherId, $zoneId, $view, $pageName, $tabIndex);
    
    $aParams = MAX_getLinkedAdParams($zoneId);
    if ($view == 'placement') {
        $aOtherAdvertisers = MAX_getEntities('advertiser', $aParams + array('agency_id' => $agencyId), false);
        $aOtherPlacements = !empty($advertiserId) ? MAX_getEntities('placement', $aParams + array('advertiser_id' => $advertiserId), false) : null;
        $aZonesPlacements = MAX_getEntities('placement_zone_assoc', array('zone_id' => $zoneId), true, 'placement_id');
        MAX_displayZoneEntitySelection('placement', $aOtherAdvertisers, $aOtherPlacements, null, $advertiserId, $placementId, $adId, $publisherId, $zoneId, $GLOBALS['strSelectCampaignToLink'], $pageName, $tabIndex);
        if (!empty($aZonesPlacements)) {
        	$aParams = array('placement_id' => implode(',', array_keys($aZonesPlacements)));
        } else {
            $aParams = null;
        }
        MAX_displayLinkedPlacementsAds($aParams, $publisherId, $zoneId, $hideInactive, $showMatchingAds, $pageName, $tabIndex);
    } elseif ($view == 'ad') {
        $aOtherAdvertisers = MAX_getEntities('advertiser', $aParams + array('agency_id' => $agencyId), false);
        $aOtherPlacements = !empty($advertiserId) ? MAX_getEntities('placement', $aParams + array('advertiser_id' => $advertiserId), false) : null;
        $aOtherAds = !empty($placementId) ? MAX_getEntities('ad', $aParams + array('placement_id' => $placementId), false) : null;
        $aAdsZones = MAX_getEntities('ad_zone_assoc', array('zone_id' => $zoneId), true, 'ad_id');
        MAX_displayZoneEntitySelection('ad', $aOtherAdvertisers, $aOtherPlacements, $aOtherAds, $advertiserId, $placementId, $adId, $publisherId, $zoneId, $GLOBALS['strSelectBannerToLink'], $pageName, $tabIndex);
        $aParams = !empty($aAdsZones) ? array('ad_id' => implode(',', array_keys($aAdsZones))) : null;
        MAX_displayLinkedAdsPlacements($aParams, $publisherId, $zoneId, $hideInactive, $showParentPlacements, $pageName, $tabIndex);
    }
?>
    
    <script language='Javascript'>
    <!--
        function toggleall()
        {
            allchecked = false;
            
            for (var i=0; i<document.zonetypeselection.elements.length; i++)
            {
                if (document.zonetypeselection.elements[i].name == 'bannerid[]' ||
                    document.zonetypeselection.elements[i].name == 'campaignid[]')
                {
                    if (document.zonetypeselection.elements[i].checked == false)
                    {
                        allchecked = true;
                    }
                }
            }
            
            for (var i=0; i<document.zonetypeselection.elements.length; i++)
            {
                if (document.zonetypeselection.elements[i].name == 'bannerid[]' ||
                    document.zonetypeselection.elements[i].name == 'campaignid[]')
                {
                    document.zonetypeselection.elements[i].checked = allchecked;
                }
            }
        }
        
        function reviewall()
        {
            allchecked = true;
            
            for (var i=0; i<document.zonetypeselection.elements.length; i++)
            {
                if (document.zonetypeselection.elements[i].name == 'bannerid[]' ||
                    document.zonetypeselection.elements[i].name == 'campaignid[]')
                {
                    if (document.zonetypeselection.elements[i].checked == false)
                    {
                        allchecked = false;
                    }
                }
            }
            
                    
            document.zonetypeselection.checkall.checked = allchecked;
        }    
    //-->
    </script>
    
    <?php
    
    $Session['prefs'][$pageName]['hideinactive'] = $hideInactive;
    $Session['prefs'][$pageName]['showbanners'] = $showMatchingAds;
    $Session['prefs'][$pageName]['showcampaigns'] = $showParentPlacements;
    $Session['prefs'][$pageName]['listorder'] = $listorder;
    $Session['prefs'][$pageName]['orderdirection'] = $orderdirection;
    $Session['prefs'][$pageName]['view'] = $view;
    
    phpAds_SessionDataStore();
    
    phpAds_PageFooter();

?>
